diff --git a/examples/tep_termination/main.c b/examples/tep_termination/main.c
index e8142e0..7c69a82 100644
--- a/examples/tep_termination/main.c
+++ b/examples/tep_termination/main.c
@@ -119,6 +119,9 @@ uint16_t num_devices;
 /* VXLAN UDP destination port */
 uint16_t udp_port;
 
+/* enable/disable inner TX checksum */
+uint8_t tx_checksum;
+
 /* RX filter type for tunneling packet */
 uint8_t filter_idx;
 
@@ -242,6 +245,7 @@ vep_termination_usage(const char *prgname)
 	RTE_LOG(INFO, VHOST_CONFIG, "%s [EAL options] -- -p PORTMASK\n"
 	"		--udp-port: UDP destination port for VXLAN packet\n"
 	"		--nb-devices: number of virtIO device\n"
+	"		--tx-checksum [0|1]: inner Tx checksum offload\n"
 	"		--filter-type[1-3]: filter type for tunneling packet\n"
 	"		    1: Inner MAC&VLAN and tenent ID\n"
 	"		    2: Inner MAC and tenent ID\n"
@@ -266,6 +270,7 @@ tep_parse_args(int argc, char **argv)
 	static struct option long_option[] = {
 		{"udp-port", required_argument, NULL, 0},
 		{"nb-devices", required_argument, NULL, 0},
+		{"tx-checksum", required_argument, NULL, 0},
 		{"filter-type", required_argument, NULL, 0},
 		{"stats", required_argument, NULL, 0},
 		{"dev-basename", required_argument, NULL, 0},
@@ -305,6 +310,16 @@ tep_parse_args(int argc, char **argv)
 					return -1;
 				}
 			}
+
+			 if (!strncmp(long_option[option_index].name, "tx-checksum", MAX_LONG_OPT_SZ)) {
+				ret = parse_num_opt(optarg, 1);
+				if (ret == -1) {
+					RTE_LOG(INFO, VHOST_CONFIG, "Invalid argument for tx-checksum [0|1]\n");
+					vep_termination_usage(prgname);
+					return -1;
+				} else
+					tx_checksum = ret;
+			}
 			
 			if (!strncmp(long_option[option_index].name, "filter-type", MAX_LONG_OPT_SZ)) {
 				ret = parse_num_opt(optarg, 3);
diff --git a/examples/tep_termination/vxlan.c b/examples/tep_termination/vxlan.c
index 942eb10..6fc75ee 100644
--- a/examples/tep_termination/vxlan.c
+++ b/examples/tep_termination/vxlan.c
@@ -43,11 +43,21 @@
 #include "main.h"
 #include "vxlan.h"
 
+extern uint8_t tx_checksum;
 extern struct vxlan_conf vxdev;
 extern struct ipv4_hdr app_ip_hdr[VXLAN_N_PORTS];
 extern struct ether_hdr app_l2_hdr[VXLAN_N_PORTS];
 extern uint16_t udp_port;
 
+static uint16_t
+get_psd_sum(void *l3_hdr, uint16_t ethertype, uint64_t ol_flags)
+{
+	if (ethertype == rte_cpu_to_be_16(ETHER_TYPE_IPv4))
+		return rte_ipv4_phdr_cksum(l3_hdr, ol_flags);
+	else /* assume ethertype == ETHER_TYPE_IPv6 */
+		return rte_ipv6_phdr_cksum(l3_hdr, ol_flags);
+}
+
 /*
  * Parse an ethernet header to fill the ethertype, l2_len, l3_len and
  * ipproto. This function is able to recognize IPv4/IPv6 with one optional vlan
@@ -87,6 +97,67 @@ parse_ethernet(struct ether_hdr *eth_hdr, struct offload_info *info)
 	}
                 
 }
+/* if possible, calculate the checksum of a packet in hw or sw,
+ *  * depending on the testpmd command line configuration */
+static uint64_t
+process_inner_cksums(struct ether_hdr *eth_hdr, struct offload_info *info)
+{
+	void *l3_hdr = NULL;
+	struct ipv4_hdr *ipv4_hdr;
+	struct ipv6_hdr *ipv6_hdr;
+	struct udp_hdr *udp_hdr;
+	struct tcp_hdr *tcp_hdr;
+	struct sctp_hdr *sctp_hdr;
+	uint64_t ol_flags = 0;
+	
+	info->l2_len = sizeof(struct ether_hdr);
+	info->ethertype = eth_hdr->ether_type;
+
+	if (info->ethertype == rte_cpu_to_be_16(ETHER_TYPE_VLAN)) {
+		struct vlan_hdr *vlan_hdr = (struct vlan_hdr *)(eth_hdr + 1);
+		info->l2_len  += sizeof(struct vlan_hdr);
+		info->ethertype = vlan_hdr->eth_proto;
+	}
+
+	l3_hdr = (char *)eth_hdr + info->l2_len;
+
+	if (info->ethertype == rte_cpu_to_be_16(ETHER_TYPE_IPv4)) {
+		ipv4_hdr = l3_hdr;
+		ipv4_hdr->hdr_checksum = 0;
+		ol_flags |= PKT_TX_IPV4;
+		ol_flags |= PKT_TX_IP_CKSUM;
+		info->l3_len = sizeof(struct ipv4_hdr);
+		info->l4_proto = ipv4_hdr->next_proto_id;
+	} else if (info->ethertype == rte_cpu_to_be_16(ETHER_TYPE_IPv6)) {
+		ipv6_hdr = l3_hdr;
+		info->l3_len = sizeof(struct ipv6_hdr);
+		info->l4_proto = ipv6_hdr->proto;
+		ol_flags |= PKT_TX_IPV6;
+	} else
+		return 0; /* packet type not supported, nothing to do */
+
+	if (info->l4_proto == IPPROTO_UDP) {
+		udp_hdr = (struct udp_hdr *)((char *)l3_hdr + info->l3_len);
+		/* do not recalculate udp cksum if it was 0 */
+		udp_hdr->dgram_cksum = 0;
+		ol_flags |= PKT_TX_UDP_CKSUM;
+		udp_hdr->dgram_cksum = get_psd_sum(l3_hdr,
+				info->ethertype, ol_flags);
+	} else if (info->l4_proto == IPPROTO_TCP) {
+		tcp_hdr = (struct tcp_hdr *)((char *)l3_hdr + info->l3_len);
+		tcp_hdr->cksum = 0;
+		ol_flags |= PKT_TX_TCP_CKSUM;
+		tcp_hdr->cksum = get_psd_sum(l3_hdr, info->ethertype,
+				ol_flags);
+
+	} else if (info->l4_proto == IPPROTO_SCTP) {
+		sctp_hdr = (struct sctp_hdr *)((char *)l3_hdr + info->l3_len);
+		sctp_hdr->cksum = 0;
+		ol_flags |= PKT_TX_SCTP_CKSUM;
+	}
+
+	return ol_flags;
+}
 
 int decapsulation(struct rte_mbuf *pkt)
 {
@@ -137,6 +208,12 @@ int encapsulation(struct rte_mbuf *m, uint8_t vport_id)
 	/* outer IP checksum */
 	ol_flags |= PKT_TX_OUTER_IP_CKSUM;
 	ip->hdr_checksum = 0;
+	if (tx_checksum) {
+		ol_flags |= process_inner_cksums(phdr, &info);
+		m->l2_len = info.l2_len;
+		m->l3_len = info.l3_len;
+		m->l2_len += ETHER_VXLAN_HLEN;
+	}
 
 	m->outer_l2_len = sizeof(struct ether_hdr);
 	m->outer_l3_len = sizeof(struct ipv4_hdr);